Redmine - Defect #14626

Repositories' extra_info column is too short with MySQL
2013-08-07 09:03 - Sergey Vasilyev

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: SCM Estimated time: 0.00 hour
Target version: 3.4.0

Resolution: Fixed Affected version: 2.3.1
Description

In the database table repositories a field named "extra_info" has type "text", which in mysql is limited to 65535 chars. This breaks
fetch_changesets command on repositories with a very large amount of branches (git). Actual reason is that is stores only part of the
last commit hash or other line (like "!b" for "Ibinary"), and this causes errors in in fetch_changeset:

$ /usr/local/rvm/bin/redmine_rails runner "Repository.fetch_changesets" -e production

/usr/local/rvm/gems/ruby-1.9.3-p429/gems/railties-3.2.13/1ib/rails/commands/runner.rb:53:in “eval'
comparison of String with nil failed (ArgumentError)

from /u0l/apps/redmine-2.3.1/app/models/repository/git.rb:145:in " fetch_changesets'

from /u0l/apps/redmine-2.3.1/app/models/repository.rb:333:in ‘block (2 levels) in fetch_change
sets'

from /usr/local/rvm/gems/ruby-1.9.3-p429/gems/activerecord-3.2.13/1ib/active_record/associatio
ns/collection_proxy.rb:89:in “each'

from /usr/local/rvm/gems/ruby-1.9.3-p429/gems/activerecord-3.2.13/1ib/active_record/associatio
ns/collection_proxy.rb:89:in ‘method_missing'

from /u0l/apps/redmine-2.3.1/app/models/repository.rb:331:in "block in fetch_changesets'

from /u0l/apps/redmine-2.3.1/app/models/repository.rb:330:in “each'

from /u0l/apps/redmine-2.3.1/app/models/repository.rb:330:in "~ fetch_changesets'

from (eval):1l:in “<top (required)>'

from /usr/local/rvm/gems/ruby-1.9.3-p429/gems/railties-3.2.13/1ib/rails/commands/runner.rb:53:
in “eval'

from /usr/local/rvm/gems/ruby-1.9.3-p429/gems/railties-3.2.13/1ib/rails/commands/runner.rb:53:
in “<top (required)>"'

from /usr/local/rvm/gems/ruby-1.9.3-p429/gems/railties-3.2.13/1ib/rails/commands.rb:64:1in "req
uire'

from /usr/local/rvm/gems/ruby-1.9.3-p429/gems/railties—-3.2.13/1ib/rails/commands.rb:64:in "<to
p (required)>'

from script/rails:6:in "require'

from script/rails:6:in " <main>'

Changing the field type to LONGTEXT fixes the problem.

Related issues:
Related to Redmine - Defect #20127: The description column in the issues tabl... Closed

Associated revisions

Revision 16446 - 2017-04-03 07:32 - Jean-Philippe Lang
Change extra_info to long text (#14626).

Patch by Go MAEDA.

History

#1 - 2013-08-07 09:07 - Toshi MARUYAMA
- Category changed from Database to SCM

#2 - 2015-10-20 01:24 - Dan Mick

Any plans to affect this?

In the meantime, not being a Rails programmer, can | change this in the database and expect the code to Just Work? (Edit: no, it'd at least take a
migration and possible code change)

#3 - 2015-11-06 10:04 - Toshi MARUYAMA
Sergey Vasilyev wrote:
Changing the field type to LONGTEXT fixes the problem.

How to change on Rails?
http://railsdoc.com/migration

#4 - 2015-11-06 10:07 - Toshi MARUYAMA

Sergey Vasilyev wrote:

This breaks fetch_changesets command on repositories with a very large amount of branches (git).

| think you had better remove merged branches.
https://github.com/sparklemotion/nokogiri/issues/1336

#5 - 2016-06-24 07:03 - Florian Gruber

encountered the same problem, Redmine version 3.1.1.stable.14752

Processing by SysController#fetch_changesets as HTML

Parameters: { "key":>"*********************" }

Mysgl2::Error: Data too long for column 'extra_info' at row 1: UPDATE " repositories’™ SET “extra_info’ U ===\

extra_report_last_commit: \'l\'\nheads:\n- !binar ....

n' WHERE “repositories’™. id" = 50

anything else to do except ?

ALTER TABLE repositories MODIFY extra_info LONGTEXT;

#6 - 2017-03-20 06:13 - Go MAEDA

- Related to Defect #20127: The description column in the issues table is too short (MySQL) added

#7 - 2017-03-20 06:26 - Go MAEDA

- File 14626-change_repositories_extra_info_limit.diff added

Shouldn't we fix this issue along with #201277?

This is a patch to fix this: 14626-change_repositories_extra_info_limit.diff

#8 - 2017-03-28 10:34 - Go MAEDA

- Target version set to 3.4.0

#9 - 2017-04-03 07:33 - Jean-Philippe Lang

- Subject changed from repositories' extra_info is too short to Repositories' extra_info column is too short with MySQL

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Committed, thanks.

Files

14626-change_repositories_extra_info_limit.diff 627 Bytes 2017-03-20 Go MAEDA
